i3 improvements
[distro-setup] / i3-abrowser
1 #!/bin/bash
2 # I, Ian Kelling, follow the GNU license recommendations at
3 # https://www.gnu.org/licenses/license-recommendations.en.html. They
4 # recommend that small programs, < 300 lines, be licensed under the
5 # Apache License 2.0. This file contains or is part of one or more small
6 # programs. If a small program grows beyond 300 lines, I plan to change
7 # to a recommended GPL license.
8
9 # Copyright 2024 Ian Kelling
10
11 # Licensed under the Apache License, Version 2.0 (the "License");
12 # you may not use this file except in compliance with the License.
13 # You may obtain a copy of the License at
14
15 # http://www.apache.org/licenses/LICENSE-2.0
16
17 # Unless required by applicable law or agreed to in writing, software
18 # distributed under the License is distributed on an "AS IS" BASIS,
19 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
20 # See the License for the specific language governing permissions and
21 # limitations under the License.
22
23 if ! test "$BASH_VERSION"; then echo "error: shell is not bash" >&2; exit 1; fi
24 shopt -s inherit_errexit 2>/dev/null ||: # ignore fail in bash < 4.4
25 set -eE -o pipefail
26 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" exit status: $?, PIPESTATUS: ${PIPESTATUS[*]}" >&2' ERR
27
28
29 # prefer abrowser
30 if type -P abrowser &>/dev/null; then
31 b=abrowser
32 else
33 b=firefox
34 fi
35
36 # mark if we dont have a mark already
37 if i3-msg -t get_tree | jq --stream -r 'select(.[1]|scalars!=null) | "\(.[0]|join(".")): \(.[1]|tojson)"' | grep 'marks.0: "abrowser"$' &>/dev/null; then
38 h=$(i3-msg -t get_tree | jq -r ".. | select(.focused? == true) | .rect.height")
39 cur_workspace=$(i3-msg -t get_workspaces | jq -r '.[] | select(.focused? == true) | .name')
40
41 # h tests if we have a current focus, but that is just a random guess.
42 if [[ $cur_workspace == 2 && $h ]]; then
43 i3-msg "swap container with mark abrowser; [con_mark=\"abrowser\"] focus"
44 else
45 i3-msg '[con_mark="abrowser"] move workspace current'
46 fi
47
48 else
49 i3-split-maybe
50 abrowser &
51 # on a fast computer, .5 is too fast, 1 is ok. on x200, 1 is too fast, 2 is ok.
52 sleep 2
53 i3-msg "[workspace=__focused__ class=\"$b\"] mark abrowser"
54 wait
55 fi